module Scrivito

#
# @api public
#
class ClassCollection
  include Enumerable

  def initialize(classes)
    @classes = classes
  end

  #
  # @!method each
  #   Iterates over the classes.
  #   @api public
  #   @yieldparam [Class] class if a block is given.
  #   @return [Enumerator] enumerator if no block is given.
  #
  delegate :each, to: :classes

  private

  attr_reader :classes
end

end
