module Scrivito

  class ClientError < StandardError
    attr_reader :http_code, :backend_code

    def initialize(message, http_code: 412, backend_code: nil)
      @http_code = http_code
      @backend_code = backend_code
      super(message)
    end

    def ==(client_error)
      return false unless client_error.is_a?(ClientError)

      message == client_error.message &&
        http_code == client_error.http_code &&
        backend_code == client_error.backend_code
    end

    def as_json
      {message: message, backendCode: backend_code}
    end
  end

end
