module Scrivito

  class CmsEnv

    OBJ_ENV_KEY = "SCRIVITO_OBJ"

    def initialize(env)
      @env = env
    end

    def load
      return if env[OBJ_ENV_KEY]
      load_object
    end

    protected

    attr_reader :env

    def load_object
      env[OBJ_ENV_KEY] =
        begin
          find_obj
        rescue StandardError => e
          e
        end
    end

    def find_obj
      found_obj =
        if id = params[:id]
          if EditingContextMiddleware.from_env(env).include_deleted_objs?
            Obj.find_including_deleted(id)
          else
            Obj.find(id)
          end
        elsif params[:permalink].present?
          permalink =  Array(params[:permalink]).join("/")
          Obj.find_by_permalink!(permalink)
        else
          Scrivito::RequestHomepage.call(env)
        end

      found_obj
    end

    def params
      env["action_dispatch.request.path_parameters"]
    end
  end
end
