module Scrivito
  class Deprecation
    def self.warn(message, source = caller(1))
      ActiveSupport::Deprecation.new(message, source).warn
    end

    def self.warn_method(deprecated_method_name, new_method_name = nil)
      warn(warn_method_message(deprecated_method_name, new_method_name), caller(1))
    end

    private_class_method def self.warn_method_message(deprecated_method_name, new_method_name = nil)
      message = "The method #{deprecated_method_name} is deprecated and will be removed "\
        "from the Scrivito SDK in the next major version. "
      message << "Please use #{new_method_name} instead" if new_method_name
      message
    end
  end
end
