module Scrivito

class LayoutTags < Struct.new(:view)
  def page_config(obj)
    if view.scrivito_user
      page_config = PageConfig.new({
        obj: obj,
        editing_context: editing_context,
        lookup_context: view.lookup_context,
      }).to_json
      view.content_tag(:div, '', 'data-scrivito-private-page-config' => page_config)
    end
  end

  def editing_auth_warning
    view.render('scrivito/editing_auth_warning') unless Configuration.editing_auth_callback
  end

  def generator_meta_tag
    content = 'Scrivito by JustRelate Group GmbH (scrivito.com)'
    content << "; Version #{GemInfo.version}" if view.scrivito_user
    view.tag(:meta, name: 'generator', content: content)
  end

  private

  def editing_context
    EditingContextMiddleware.from_request(view.request)
  end
end

end
