module Scrivito
  module Migrations
    class Migration
      def self.next_migration_number(current_migration_number)
        migration_number = current_migration_number + 1
        [Time.now.utc.strftime('%Y%m%d%H%M%S'), '%.14d' % migration_number].max
      end

      attr_accessor :name
      attr_accessor :version
      attr_accessor :filename
      attr_accessor :scope

      def initialize(name, version, filename, scope)
        @name = name
        @version = version.to_i
        @filename = filename
        @scope = scope.to_s
      end

      def migrate
        announce 'migrating'

        time = Benchmark.measure { up }

        announce 'migrated (%.4fs)' % time.real; puts
      end

      private

      def announce(message)
        text = "#{version} #{name}: #{message}"
        length = [0, 75 - text.length].max
        puts('== %s %s' % [text, '=' * length])
      end
    end
  end
end
