require 'singleton'

module Scrivito
  module Migrations
    class MigrationStore
      include Singleton

      def backend
        @backend ||= CmsBackend.new
      end

      def versions
        @versions ||= JSON.parse(backend.read.presence || '[]')
      end

      def add_version(version)
        versions << version
        backend.save(JSON.generate(versions))
      end
    end
  end
end
