module Scrivito
class ObjSearchEnumerator
  class QueryExecutor
    def initialize(workspace)
      @workspace = workspace
    end

    def call(query, continuation=nil, fetched_ids=[])
      query['continuation'] = continuation if continuation
      response = Scrivito::CmsBackend.search_objs(workspace, query)

      Scrivito::ObjSearchEnumerator::Batch.new(
        build_objs(response),
        response['total'].to_i,
        response['continuation'],
        response['facets'],
        fetched_ids
      )
    end

    private

    attr_reader :workspace

    def build_objs(response)
      obj_ids = response['results'].map { |result| result['id'] }
      if obj_ids.present?
        workspace.objs.find_including_deleted(obj_ids)
      else
        []
      end
    end
  end
end
end
