module Scrivito
  module Generators
    class WidgetGenerator < ::Rails::Generators::NamedBase
      source_root File.expand_path('../templates', __FILE__)

      argument :name, type: :string
      argument :attrs, type: :array, default: [], banner: 'attribute:type attribute:type'

      def create_model
        template 'model.erb', "app/models/#{file_name}.rb"
      end

      def create_views
        template 'show.html.erb', "app/views/#{file_name}/show.html.erb"
        template 'details.html.erb', "app/views/#{file_name}/details.html.erb"
        template 'thumbnail.html.erb', "app/views/#{file_name}/thumbnail.html.erb"
      end

      def file_name
        super.ends_with?('_widget') ? super : "#{super}_widget"
      end

      def class_name
        super.ends_with?('Widget') ? super : "#{super}Widget"
      end
    end
  end
end
